// 
//

#include "stdafx.h"
#include "..\common\WebUtil.h"
#define PL_TIME MAKELONG( CEVT_FILETIME, 0x0 )
#define PL_ITEM	MAKELONG( CEVT_BLOB, 0x1 )

#define MAX_DBNAME 256
#define ISKANJI(c) ((uchar)(c)>=0x80)

// ----------------------------------------------------------------------------
// G[\
// ----------------------------------------------------------------------------
void Error(MyVarMem* pRes, char* pszErrorString)
{
	pRes->Clear();
	pRes->Add("Content-Type: text/html\r\n\r\n");
	pRes->Add("<HTML><BODY>");
	pRes->Add(pszErrorString);
	pRes->Add("</BODY></HTML>");
}

// ----------------------------------------------------------------------------
// HTML wb_[o
// ----------------------------------------------------------------------------
void HTML_HEADER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add( 
		"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\n"
		"<HTML><HEAD>\n"
		"<TITLE>CEHTTP BBS</TITLE>\n"
		"</HEAD>\n"
		"<BODY>\n");

	return;
}

// ----------------------------------------------------------------------------
// HTML tb^[o
// ----------------------------------------------------------------------------
void HTML_FOOTER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add(
		"<HR><A HREF=\"http://www001.upp.so-net.ne.jp/ishi/\">CEHTTP BBS by IshiSoft</A>"
		"</BODY></HTML>\n");
}

// ----------------------------------------------------------------------------
// DB
// ----------------------------------------------------------------------------
void EnumDbase( WebUtil* pwu )
{
	MyHash* pEnv = pwu->GetEnv();
	MyVarMem* pBody	= pwu->GetBody();
	MyVarMem* pRes = pwu->GetRes();
	HANDLE hEnum = NULL;
	CEOID db = 0;
	CEOIDINFO obj;
	DWORD      dwErr;

	char	szFmt[512];

	char* p;

	if( (hEnum = CeFindFirstDatabase(0)) != INVALID_HANDLE_VALUE)
	{
		pRes->Add(
			"<table cellspacing=\"0\">\n"
			"<tr bgcolor=\"#CCFFCC\">\n"
			"<td>Database name</td>\n"
			"<td align=\"right\">size</td>\n"
			"<td align=\"right\">records</td>\n"
			"<td align=\"right\">oid</td>\n"
			"<td align=\"right\">wNumSortOrder</td>\n"
			"<td align=\"right\">command</td>\n"
			"</tr>\n" );
		while( (db = CeFindNextDatabase(hEnum)) != 0)
		{
			if ( !CeOidGetInfo(db, &obj) )
			{
				sprintf(szFmt, "CeOidGetInfo failed with error (%ld)", GetLastError());
				pRes->Add(szFmt);
				break;
			}
			else
			{
				p = WStrToStrAlloc(obj.infDatabase.szDbaseName);
				
				if( p != NULL )
				{
					if( strncmp(p, "CEHTTP_", 7) == 0 )
					{
						sprintf(szFmt, 
							" <tr bgcolor=\"#CCCCFF\">\n"
							"  <td><a href=\"%s?cmd=enum&name=%s\">	%s  </a></td>\n"
							"  <td align=\"right\">  %d</td>\n"
							"  <td align=\"right\">  %d</td>\n"
							"  <td align=\"right\">  %#X</td>\n"
							"  <td align=\"right\">  %d</td>\n"
							"  <td><a href=\"%s?cmd=deleteDB&db=%d\">DELETE DB</a></td>\n"
							" </tr>\n"
							
							, pEnv->GetValue("SCRIPT_NAME"), p, p
							, obj.infDatabase.dwSize
							, obj.infDatabase.wNumRecords
							, db
							, obj.infDatabase.wNumSortOrder
							, pEnv->GetValue("SCRIPT_NAME"), db
							);

						pRes->Add(szFmt);
					}
					else
					{
						sprintf(szFmt, 
							" <tr bgcolor=\"#FFFFFF\">\n"
							"  <td>%s</td>\n"
							"  <td align=\"right\">%d</td>\n"
							"  <td align=\"right\">%d</td>\n"
							"  <td align=\"right\">%#X</td>\n"
							"  <td align=\"right\">  %d</td>\n"
							" </tr>\n"
							, p
							, obj.infDatabase.dwSize
							, obj.infDatabase.wNumRecords
							, db
							, obj.infDatabase.wNumSortOrder
							);

						pRes->Add(szFmt);
					}
					free( p );
				}


			}

		}
		pRes->Add("</table>\n");

		if ( (dwErr = GetLastError()) != ERROR_NO_MORE_ITEMS )
		{
			sprintf(szFmt, "CeFindFirstDatabase failed with error (%ld)\n", dwErr);
			pRes->Add(szFmt);
		}

	}
	else
	{
		sprintf(szFmt, "CeFindFirstDatabase failed with error (%ld)\n", GetLastError());
		pRes->Add(szFmt);
	}
}

// ----------------------------------------------------------------------------
// ^O폜
// ----------------------------------------------------------------------------
void StripTag(char* pDst, int nLen, const char* pSrc)
{
	int flag = 1;
	int ii = 0;
	*pDst = '\0';

	do
	{
		if( *pSrc == '<' )
		{
			flag = 0;
			pSrc++;
			continue;
		}
		
		if( *pSrc == '>' )
		{
			flag = 1;
			pSrc++;
			continue;
		}

		if( flag )
		{
			*pDst++ = *pSrc;
			ii ++;
		}
		pSrc++;
		*pDst = '\0';
	}
	while( *pSrc != '\0' && ii < nLen );
}

// ----------------------------------------------------------------------------
// R[h
// ----------------------------------------------------------------------------
int EnumRecord( WebUtil* pwu )
{
	char szDBName[MAX_DBNAME] = {0};

	if( !pwu->GetItem( "name=", szDBName, MAX_DBNAME ) )
	{
		Error( pwu->m_pRes, "DB not found" );
		return 0;
	}

	if( 0 != STRNICMP( szDBName, "CEHTTP_", 7 ) )
	{
		Error( pwu->m_pRes, "It is not CEHTTP DB." );
		return 0;
	}

	WCHAR	wszDBName[256] = {0};
	
	if( 0 == MultiByteToWideChar(CP_ACP, 0, szDBName, -1, wszDBName, MAX_DBNAME) )
	{
		Error( pwu->m_pRes, "MultiByteToWideChar failed." );
		return 0;
	}

	
	HANDLE	hDB;
	DWORD	dwError;

	CEGUID	ceguid;
	CEOID	CeOid;

	CREATE_SYSTEMGUID( &ceguid );
	CeOid = 0;



	// --------------------------------------------------------------
	// DBI[v
	// --------------------------------------------------------------
	hDB = CeOpenDatabaseEx(&ceguid, &CeOid, wszDBName, 0, CEDB_AUTOINCREMENT, NULL);

	if (hDB == INVALID_HANDLE_VALUE)
	{
		Error( pwu->m_pRes, "CeOpenDatabaseEx failed." );
		return 0;
	}

	// --------------------------------------------------------------
	// R[hǂݏo
	// --------------------------------------------------------------
	WORD		wcPropID = 0;
	BYTE*		pBuffer = NULL;
	DWORD		dwcbBuffer = 0;
	PCEPROPVAL	pVals;
	char		pszLink[512] = {0};
	int			nRowCount = 0;

	while ((CeOid = CeReadRecordProps(hDB, CEDB_ALLOWREALLOC, &wcPropID, NULL, &pBuffer, &dwcbBuffer)))
	{
		pVals = (PCEPROPVAL)pBuffer;

		// BODY -----------------------------------------------------
		for( int ii = 0; ii < wcPropID; ii++ )
		{
			if( pVals[ii].propid == PL_ITEM )
			{
				const char* p = (const char*)(pVals[ii].val.blob.lpb);

				// o
				char szBuf[256] = {0};

				StripTag( szBuf, 255, p );
				
				sprintf( pszLink, "<A HREF=\"%s?cmd=deleteitem&dbname=%s&deleteitem=%d\">delete:</A>"
					, pwu->m_pEnv->GetValueI( "SCRIPT_NAME" ), szDBName, CeOid );
				pwu->m_pRes->Add( pszLink );
				pwu->m_pRes->Add( "<TT>" );
				pwu->m_pRes->Add( szBuf );
				pwu->m_pRes->Add( "</TT>" );
				//pwu->m_pRes->Add( p, pVals[ii].val.blob.dwCount );
				pwu->m_pRes->Add( "<BR>\n" );
			}
		}

		LocalFree(pBuffer);
		pBuffer = NULL;
	}

	dwError = GetLastError();

	sprintf( pszLink, "<A HREF=\"%s?\">TOP</A> ", pwu->m_pEnv->GetValueI( "SCRIPT_NAME" ) );

	if( dwError == NO_ERROR )
	{
		pwu->m_pRes->Add( pszLink );
	}
	else if (dwError == ERROR_NO_MORE_ITEMS)
	{
		pwu->m_pRes->Add( pszLink );
	}
	else if (dwError == ERROR_INSUFFICIENT_BUFFER)
	{
		Error(pwu->m_pRes, "Re-allocation of database records failed.");	}
	else
	{
		Error(pwu->m_pRes, "Other errors.");
	}

	// Close the database handle.

	CloseHandle (hDB);

	return TRUE;
}

// ----------------------------------------------------------------------------
// f[^x[X폜
// ----------------------------------------------------------------------------
void DeleteDB( WebUtil* pwu )
{
	MyVarMem* pRes = pwu->GetRes();

	CEGUID ceguid;
	CEOID CeOid = 0;
	CEOIDINFO obj;
	CREATE_SYSTEMGUID( &ceguid );

	CeOid = (CEOID)pwu->GetItemInt("db=");

	if ( !CeOidGetInfo(CeOid, &obj) )
	{
		Error(pRes, "CeOidGetInfo failed with error.");
		return;
	}

	if( obj.wObjType != OBJTYPE_DATABASE )
	{
		Error(pRes, "This oid is not database type.");
		return;
	}

	char* p = WStrToStrAlloc(obj.infDatabase.szDbaseName);
	
	if( p == NULL )
	{
		Error(pRes, "Memory alloc failed.");
		return;
	}

	if( strncmp(p, "CEHTTP_", 7) == 0 )
	{
		if( CeDeleteDatabase(CeOid) )
		{
			Error(pRes, "Database deleted.");
		}
		else
		{
			Error(pRes, "Database failed.");
		}
	}
	else
	{
		Error(pRes, "This is not CEHTTP family.");
	}
	free(p);
}

// ----------------------------------------------------------------------------
// R[h폜
// ----------------------------------------------------------------------------
BOOL DeleteItem( WebUtil* pwu )
{
	CHAR szDBName[MAX_DBNAME] = {0};
	WCHAR wszDBName[MAX_DBNAME] = {0};
	CEOID oidRecord = (CEOID)pwu->GetItemInt( "deleteitem=" );
	MyVarMem* pRes = pwu->m_pRes; 

	HANDLE	hDB;
	CEGUID	ceguid;
	CEOID	CeOid;
	CREATE_SYSTEMGUID( &ceguid );
	CeOid = 0;
	char szBuf[256] = {0};

	if( !pwu->GetItem( "dbname=", szDBName, MAX_DBNAME-1 ) )
	{
		Error(pRes, "Open database Error");
		return FALSE;
	}

	if( 0 == MultiByteToWideChar(CP_ACP, 0, szDBName, -1, wszDBName, MAX_DBNAME-1 ) )
	{
		Error( pwu->m_pRes, "MultiByteToWideChar failed." );
		return 0;
	}

	hDB = CeOpenDatabaseEx(&ceguid, &CeOid, wszDBName, 0, CEDB_AUTOINCREMENT, NULL);

	if (hDB == INVALID_HANDLE_VALUE)
	{
		CloseHandle( hDB );
		Error(pRes, "Open database Error");
		return FALSE;
	}
	else if( !CeDeleteRecord( hDB, oidRecord ) )
	{
		CloseHandle( hDB );
		sprintf( szBuf,
			"CeDeleteRecord was fail with error %d<BR>\n"
			"Database %d(%08X)<BR>\n"
			"Record %d(%08X)"
			, GetLastError()
			, hDB, hDB
			, oidRecord, oidRecord
			);
		Error(pRes, szBuf);
		return FALSE;
	}
	CloseHandle( hDB );
	return TRUE;
}

//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		s0ԂĂB
//		ȊO͐̒lԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	WebUtil	wu(pEnv, pBody, pRes);

	pRes->Clear();
	pRes->Add( "Content-Type: text/html\r\n\r\n" );
	char	szCommand[64] = {0};
	
	HTML_HEADER( pEnv, pRes );
	wu.GetItem("cmd=", szCommand, 63);
	
	if( STRICMP( szCommand, "deletedb" ) == 0 )
	{
		DeleteDB( &wu );
	}
	else if( STRICMP( szCommand, "deleteitem" ) == 0 )
	{
		if( !DeleteItem( &wu ) )
			return pRes->GetLength();

		EnumRecord( &wu );
		return pRes->GetLength();
	}
	else if( STRICMP( szCommand, "enum" ) == 0 )
	{
		if( !EnumRecord( &wu ) )
			return pRes->GetLength();
	}
	else
	{
		EnumDbase( &wu );
	}

	HTML_FOOTER( pEnv, pRes );

	return pRes->GetLength();
}

//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}
